﻿using System;
using System.Diagnostics;
using Silanis.ESL.SDK;
using Silanis.ESL.SDK.Builder;
using System.IO;
using System.Collections.Generic;
using System.Net;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using Newtonsoft.Json.Linq;

namespace documentLayouts
{
    class CreatingLayoutsREST
    {
        //replace api_key placeholder with your own value
        private static String apiUrl = "https://sandbox.e-signlive.com/api";
        private static String apiKey = "api_key";

        public static void Main(string[] args)
        {

            string jsonString = "{\"name\":\"Layout 02\",\"type\":\"LAYOUT\",\"id\":\"packageId\",\"visibility\":\"SENDER\",\"documents\":[ { \"id\":\"documentId\"}]}";
            StringContent jsonContent = new StringContent(jsonString, Encoding.UTF8, "application/json");

            HttpClient myClient = new HttpClient();
            myClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", apiKey);
            myClient.DefaultRequestHeaders.Add("Accept", "application/json");

            //retrieve all layouts
            var layouts = myClient.GetAsync(new Uri(apiUrl + "?from=0&to=100")).Result;
            JObject layoutsJSON = JObject.Parse(layouts.Content.ReadAsStringAsync().Result);
            var results = layoutsJSON["results"];

            //print layout ids
            foreach (var q in results)
            {
                var name = q["name"];
                var id = q["id"];
                Debug.WriteLine(name + " " + id);
            }

            //apply layout
            var response = myClient.PostAsync(new Uri(apiUrl + "{packageId}/documents/{documentId}/layout?layoutId=fb76da60-b4ad-4c97-8b93-da48c0384601"), jsonContent).Result;
            Debug.WriteLine(response.Content.ReadAsStringAsync().Result);
        }
    }
}
